Index: trunk/geant4/visualization/management/include/G4VisManager.hh
===================================================================
--- trunk/geant4/visualization/management/include/G4VisManager.hh	(revision 592)
+++ trunk/geant4/visualization/management/include/G4VisManager.hh	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VisManager.hh,v 1.65 2006/11/21 14:23:20 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4VisManager.hh,v 1.67 2007/07/10 17:49:27 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -344,9 +344,8 @@
   // GetXGeometryString and GetWindowSizeHint is guaranteed to be
   // identical.)
-  const G4String&              GetBeginOfLastRunRandomStatus   () const;
-  const G4String&              GetBeginOfLastEventRandomStatus () const;
-  G4int                        GetLastRunID                    () const;
   G4bool                       GetTransientsDrawnThisRun       () const;
   G4bool                       GetTransientsDrawnThisEvent     () const;
+  const G4Event*               GetRequestedEvent               () const;
+  G4bool                       GetAbortReviewKeptEvents        () const;
 
   void SetUserAction (G4VUserVisAction* pVisAction,
@@ -366,4 +365,7 @@
   void              SetEventRefreshing          (G4bool);
   void              ResetTransientsDrawnFlags   ();
+  // If non-zero, requested event is used in G4VSceneHandler::ProcessScene.
+  void              SetRequestedEvent           (const G4Event*);
+  void              SetAbortReviewKeptEvents    (G4bool);
 
   /////////////////////////////////////////////////////////////////////
@@ -436,11 +438,13 @@
   G4VisStateDependent*  fpStateDependent;   // Friend state dependent class.
   G4int fWindowSizeHintX, fWindowSizeHintY; // For viewer...
-  G4String fXGeometryString;                // ...construction.
-  G4TrajectoriesModel dummyTrajectoriesModel;  // For passing drawing mode.
-  G4bool fEventRefreshing;
-  G4bool fTransientsDrawnThisRun;
-  G4bool fTransientsDrawnThisEvent;
-  G4bool fEventKeepingSuspended;
-  G4bool fKeptLastEvent;
+  G4String              fXGeometryString;   // ...construction.
+  G4TrajectoriesModel   dummyTrajectoriesModel;  // For passing drawing mode.
+  G4bool                fEventRefreshing;
+  G4bool                fTransientsDrawnThisRun;
+  G4bool                fTransientsDrawnThisEvent;
+  G4bool                fEventKeepingSuspended;
+  G4bool                fKeptLastEvent;
+  const G4Event*        fpRequestedEvent; // If non-zero, scene handler uses.
+  G4bool                fAbortReviewKeptEvents;
 
   // Trajectory draw model manager
Index: trunk/geant4/visualization/management/include/G4VisManager.icc
===================================================================
--- trunk/geant4/visualization/management/include/G4VisManager.icc	(revision 592)
+++ trunk/geant4/visualization/management/include/G4VisManager.icc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VisManager.icc,v 1.19 2006/11/14 14:59:55 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4VisManager.icc,v 1.20 2007/01/11 16:40:58 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -90,4 +90,12 @@
 }
 
+inline const G4Event* G4VisManager::GetRequestedEvent() const {
+  return fpRequestedEvent;
+}
+
+inline G4bool G4VisManager::GetAbortReviewKeptEvents() const {
+  return fAbortReviewKeptEvents;
+}
+
 inline void G4VisManager::SetUserActionExtent (const G4VisExtent& extent) {
   fUserVisActionExtent = extent;
@@ -122,2 +130,10 @@
   fMessengerList.push_back(msgr);
 }
+
+inline void G4VisManager::SetRequestedEvent (const G4Event* event) {
+  fpRequestedEvent = event;
+}
+
+inline void G4VisManager::SetAbortReviewKeptEvents (G4bool abort) {
+  fAbortReviewKeptEvents = abort;
+}
Index: trunk/geant4/visualization/management/include/G4VisModelManager.hh
===================================================================
--- trunk/geant4/visualization/management/include/G4VisModelManager.hh	(revision 592)
+++ trunk/geant4/visualization/management/include/G4VisModelManager.hh	(revision 593)
@@ -25,5 +25,5 @@
 //
 // $Id: G4VisModelManager.hh,v 1.4 2006/06/29 21:29:10 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // Generic model manager. Manages models, associated
Index: trunk/geant4/visualization/management/include/G4VisStateDependent.hh
===================================================================
--- trunk/geant4/visualization/management/include/G4VisStateDependent.hh	(revision 592)
+++ trunk/geant4/visualization/management/include/G4VisStateDependent.hh	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VisStateDependent.hh,v 1.5 2006/06/29 21:29:12 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // A "state dependent" service class for G4VisManager.
Index: trunk/geant4/visualization/management/src/G4GraphicsSystemList.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4GraphicsSystemList.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4GraphicsSystemList.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GraphicsSystemList.cc,v 1.4 2006/06/29 21:29:14 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 #include "G4GraphicsSystemList.hh"
Index: trunk/geant4/visualization/management/src/G4Scene.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4Scene.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4Scene.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Scene.cc,v 1.23 2006/11/26 15:51:12 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/management/src/G4SceneHandlerList.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4SceneHandlerList.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4SceneHandlerList.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SceneHandlerList.cc,v 1.4 2006/06/29 21:29:18 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 #include "G4SceneHandlerList.hh"
Index: trunk/geant4/visualization/management/src/G4SceneList.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4SceneList.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4SceneList.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SceneList.cc,v 1.6 2006/06/29 21:29:20 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 #include "G4SceneList.hh"
Index: trunk/geant4/visualization/management/src/G4VGraphicsSystem.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4VGraphicsSystem.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4VGraphicsSystem.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VGraphicsSystem.cc,v 1.11 2006/06/29 21:29:22 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/management/src/G4VSceneHandler.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4VSceneHandler.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4VSceneHandler.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VSceneHandler.cc,v 1.77 2006/11/21 14:23:53 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4VSceneHandler.cc,v 1.82 2007/05/16 15:47:44 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -71,4 +71,6 @@
 #include "G4ModelingParameters.hh"
 #include "G4VTrajectory.hh"
+#include "G4VTrajectoryPoint.hh"
+#include "G4HitsModel.hh"
 #include "G4VHit.hh"
 #include "Randomize.hh"
@@ -77,4 +79,6 @@
 #include "G4Run.hh"
 #include "G4Transform3D.hh"
+#include "G4AttHolder.hh"
+#include "G4AttDef.hh"
 
 G4VSceneHandler::G4VSceneHandler (G4VGraphicsSystem& system, G4int id, const G4String& name):
@@ -95,6 +99,5 @@
   fpObjectTransformation (0),
   fNestingDepth          (0),
-  fpVisAttribs           (0),
-  fRequestedEvent        (0)
+  fpVisAttribs           (0)
 {
   G4VisManager* pVMan = G4VisManager::GetInstance ();
@@ -421,12 +424,9 @@
   G4NURBS* pNURBS = 0;
   G4Polyhedron* pPolyhedron = 0;
-  const G4VisAttributes* pVisAttribs =
-    fpViewer -> GetApplicableVisAttributes (fpVisAttribs);
   switch (fpViewer -> GetViewParameters () . GetRepStyle ()) {
   case G4ViewParameters::nurbs:
     pNURBS = solid.CreateNURBS ();
     if (pNURBS) {
-      pNURBS -> SetVisAttributes
-	(fpViewer -> GetApplicableVisAttributes (pVisAttribs));
+      pNURBS -> SetVisAttributes (fpVisAttribs);
       AddPrimitive (*pNURBS);
       delete pNURBS;
@@ -447,9 +447,9 @@
   case G4ViewParameters::polyhedron:
   default:
-    G4Polyhedron::SetNumberOfRotationSteps (GetNoOfSides (pVisAttribs));
+    G4Polyhedron::SetNumberOfRotationSteps (GetNoOfSides (fpVisAttribs));
     pPolyhedron = solid.GetPolyhedron ();
     G4Polyhedron::ResetNumberOfRotationSteps ();
     if (pPolyhedron) {
-      pPolyhedron -> SetVisAttributes (pVisAttribs);
+      pPolyhedron -> SetVisAttributes (fpVisAttribs);
       AddPrimitive (*pPolyhedron);
     }
@@ -471,5 +471,5 @@
 
 void G4VSceneHandler::ProcessScene (G4VViewer&) {
-  printf("G4VSceneHandler::ProcessScene\n");
+
   if (!fpScene) return;
 
@@ -545,68 +545,61 @@
   G4StateManager* stateManager = G4StateManager::GetStateManager();
   G4ApplicationState state = stateManager->GetCurrentState();
-
-  printf("G4VSceneHandler::ProcessScene 1\n");
   if (state == G4State_Idle) {
-  printf("G4VSceneHandler::ProcessScene 2 : idle\n");
 
     visManager->SetEventRefreshing(true);
 
-    if (fRequestedEvent) {
-      DrawEvent(fRequestedEvent);
-      printf("G4VSceneHandler::ProcessScene 3 : fRequestedEvent\n");
+    if (visManager->GetRequestedEvent()) {
+      DrawEvent(visManager->GetRequestedEvent());
 
     } else {
-      printf("G4VSceneHandler::ProcessScene 3 : not fRequestedEvent\n");
 
       G4RunManager* runManager = G4RunManager::GetRunManager();
-      const G4Run* run = runManager->GetCurrentRun();
-      const std::vector<const G4Event*>* events =
-	run? run->GetEventVector(): 0;
-      size_t nKeptEvents = 0;
-      if (events) nKeptEvents = events->size();
       if (runManager) {
-          printf("G4VSceneHandler::ProcessScene 4 : run manager OK\n");
-	if (fpScene->GetRefreshAtEndOfEvent()) {
-          printf("G4VSceneHandler::ProcessScene 5 : fpScene->GetRefreshAtEndOfEvent()\n");
-
-	  if (verbosity >= G4VisManager::confirmations) {
-	    G4cout << "Refreshing event..." << G4endl;
-	  }
-	  const G4Event* event = 0;
-	  if (events && events->size()) event = events->back();
-	  if (event) DrawEvent(event);
-
-	} else {  // Accumulating events.
-  printf("G4VSceneHandler::ProcessScene 7\n");
-
-	  if (verbosity >= G4VisManager::confirmations) {
-	    G4cout << "Refreshing events in run..." << G4endl;
-	  }
-	  for (size_t i = 0; i < nKeptEvents; ++i) {
-	    const G4Event* event = (*events)[i];
+	const G4Run* run = runManager->GetCurrentRun();
+	const std::vector<const G4Event*>* events =
+	  run? run->GetEventVector(): 0;
+	size_t nKeptEvents = 0;
+	if (events) nKeptEvents = events->size();
+	if (nKeptEvents) {
+
+	  if (fpScene->GetRefreshAtEndOfEvent()) {
+
+	    if (verbosity >= G4VisManager::confirmations) {
+	      G4cout << "Refreshing event..." << G4endl;
+	    }
+	    const G4Event* event = 0;
+	    if (events && events->size()) event = events->back();
 	    if (event) DrawEvent(event);
-	  }
-
-	  if (!fpScene->GetRefreshAtEndOfRun()) {
-	    if (verbosity >= G4VisManager::warnings) {
-	      G4cout <<
-		"WARNING: Cannot refresh events accumulated over more"
-		"\n  than one runs.  Refreshed just the last run..."
-		     << G4endl;
+
+	  } else {  // Accumulating events.
+
+	    if (verbosity >= G4VisManager::confirmations) {
+	      G4cout << "Refreshing events in run..." << G4endl;
+	    }
+	    for (size_t i = 0; i < nKeptEvents; ++i) {
+	      const G4Event* event = (*events)[i];
+	      if (event) DrawEvent(event);
+	    }
+
+	    if (!fpScene->GetRefreshAtEndOfRun()) {
+	      if (verbosity >= G4VisManager::warnings) {
+		G4cout <<
+		  "WARNING: Cannot refresh events accumulated over more"
+		  "\n  than one runs.  Refreshed just the last run."
+		       << G4endl;
+	      }
 	    }
 	  }
 	}
       }
-   }
-   visManager->SetEventRefreshing(false);
- }
+    }
+    visManager->SetEventRefreshing(false);
+  }
 
   fMarkForClearingTransientStore = tmpMarkForClearingTransientStore;
-  printf("G4VSceneHandler::ProcessScene terminé \n");
 }
 
 void G4VSceneHandler::DrawEvent(const G4Event* event)
 {
-  printf("G4VSceneHandler::DrawEvent \n");
   const std::vector<G4VModel*>& EOEModelList =
     fpScene -> GetEndOfEventModelList ();
@@ -718,4 +711,55 @@
 }
 
+void G4VSceneHandler::LoadAtts(const G4Visible& visible, G4AttHolder* holder)
+{
+  // Load G4Atts from G4VisAttributes, if any...
+  const G4VisAttributes* va = visible.GetVisAttributes();
+  if (va) {
+    const std::map<G4String,G4AttDef>* vaDefs =
+      va->GetAttDefs();
+    if (vaDefs) {
+      holder->AddAtts(visible.GetVisAttributes()->CreateAttValues(), vaDefs);
+    }
+  }
+
+  G4PhysicalVolumeModel* pPVModel =
+    dynamic_cast<G4PhysicalVolumeModel*>(fpModel);
+  if (pPVModel) {
+    // Load G4Atts from G4PhysicalVolumeModel...
+    const std::map<G4String,G4AttDef>* defs = pPVModel->GetAttDefs();
+    if (defs) {
+      holder->AddAtts(pPVModel->CreateCurrentAttValues(), defs);
+    }
+  }
+
+  G4TrajectoriesModel* trajModel = dynamic_cast<G4TrajectoriesModel*>(fpModel);
+  if (trajModel) {
+    // Load G4Atts from trajectory...
+    const G4VTrajectory* traj = trajModel->GetCurrentTrajectory();
+    const std::map<G4String,G4AttDef>* defs = traj->GetAttDefs();
+    if (defs) {
+      holder->AddAtts(traj->CreateAttValues(), defs);
+    }
+    G4int nPoints = traj->GetPointEntries();
+    for (G4int i = 0; i < nPoints; ++i) {
+      G4VTrajectoryPoint* trajPoint = traj->GetPoint(i);
+      const std::map<G4String,G4AttDef>* defs = trajPoint->GetAttDefs();
+      if (defs) {
+	holder->AddAtts(trajPoint->CreateAttValues(), defs);
+      }
+    }
+  }
+
+  G4HitsModel* hitsModel = dynamic_cast<G4HitsModel*>(fpModel);
+  if (hitsModel) {
+    // Load G4Atts from hit...
+    const G4VHit* hit = hitsModel->GetCurrentHit();
+    const std::map<G4String,G4AttDef>* defs = hit->GetAttDefs();
+    if (defs) {
+      holder->AddAtts(hit->CreateAttValues(), defs);
+    }
+  }
+}
+
 const G4Colour& G4VSceneHandler::GetColour (const G4Visible& visible) {
   // Colour is determined by the applicable vis attributes.
@@ -734,8 +778,7 @@
 }
 
-G4double G4VSceneHandler::GetLineWidth(const G4Visible& visible)
-{
-  G4double lineWidth = fpViewer->
-    GetApplicableVisAttributes(visible.GetVisAttributes())->GetLineWidth();
+G4double G4VSceneHandler::GetLineWidth(const G4VisAttributes* pVisAttribs)
+{
+  G4double lineWidth = pVisAttribs->GetLineWidth();
   if (lineWidth < 1.) lineWidth = 1.;
   lineWidth *= fpViewer -> GetViewParameters().GetGlobalLineWidthScale();
@@ -749,5 +792,5 @@
   // it can be overriddden by the ForceDrawingStyle flag in the vis
   // attributes.
-  G4ViewParameters::DrawingStyle style =
+  G4ViewParameters::DrawingStyle style = 
     fpViewer->GetViewParameters().GetDrawingStyle();
   if (pVisAttribs -> IsForceDrawingStyle ()) {
@@ -821,13 +864,15 @@
   // ForceLineSegmentsPerCircle in the vis attributes.
   G4int lineSegmentsPerCircle = fpViewer->GetViewParameters().GetNoOfSides();
-  if (pVisAttribs->GetForcedLineSegmentsPerCircle() > 0)
-    lineSegmentsPerCircle = pVisAttribs->GetForcedLineSegmentsPerCircle();
-  const G4int nSegmentsMin = 12;
-  if (lineSegmentsPerCircle < nSegmentsMin) {
-    lineSegmentsPerCircle = nSegmentsMin;
-    G4cout <<
-      "G4VSceneHandler::GetNoOfSides: attempt to set the"
-      "\nnumber of line segements per circle < " << nSegmentsMin
-         << "; forced to " << lineSegmentsPerCircle << G4endl;
+  if (pVisAttribs) {
+    if (pVisAttribs->IsForceLineSegmentsPerCircle())
+      lineSegmentsPerCircle = pVisAttribs->GetForcedLineSegmentsPerCircle();
+    const G4int nSegmentsMin = 12;
+    if (lineSegmentsPerCircle < nSegmentsMin) {
+      lineSegmentsPerCircle = nSegmentsMin;
+      G4cout <<
+	"G4VSceneHandler::GetNoOfSides: attempt to set the"
+	"\nnumber of line segements per circle < " << nSegmentsMin
+	     << "; forced to " << lineSegmentsPerCircle << G4endl;
+    }
   }
   return lineSegmentsPerCircle;
Index: trunk/geant4/visualization/management/src/G4VViewer.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4VViewer.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4VViewer.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VViewer.cc,v 1.23 2006/06/29 21:29:26 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// $Id: G4VViewer.cc,v 1.24 2007/01/05 16:25:15 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -82,5 +82,5 @@
 const G4VisAttributes* G4VViewer::GetApplicableVisAttributes
 (const G4VisAttributes* pVisAttribs) const {
-  // If the pointer is null, pick up the default vis attributes from
+  // If pVisAttribs is zero, pick up the default vis attributes from
   // the view parameters.
   if (!pVisAttribs)
Index: trunk/geant4/visualization/management/src/G4VVisCommand.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4VVisCommand.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4VVisCommand.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VVisCommand.cc,v 1.18 2006/06/29 21:29:28 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 // Base class for visualization commands - John Allison  9th August 1998
Index: trunk/geant4/visualization/management/src/G4ViewParameters.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4ViewParameters.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4ViewParameters.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ViewParameters.cc,v 1.28 2006/09/19 16:02:31 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4ViewParameters.cc,v 1.29 2007/04/03 13:33:16 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -72,5 +72,6 @@
   fWindowSizeHintY (600),
   fAutoRefresh (false),
-  fBackgroundColour (G4Colour(0.,0.,0.))          // Black
+  fBackgroundColour (G4Colour(0.,0.,0.)),         // Black
+  fPicking (false)
 {
   fDefaultMarker.SetScreenSize (5.);
@@ -273,5 +274,7 @@
       (fXGeometryString      != v.fXGeometryString)      ||
       (fAutoRefresh          != v.fAutoRefresh)          ||
-      (fBackgroundColour     != v.fBackgroundColour))
+      (fBackgroundColour     != v.fBackgroundColour)     || 
+      (fPicking              != v.fPicking)
+      )
     G4cout << "Difference in 1st batch." << G4endl;
 
@@ -439,4 +442,8 @@
 
   os << "\n  Background colour: " << v.fBackgroundColour;
+
+  os << "\n  Picking requested: ";
+  if (v.fPicking) os << "true";
+  else os << "false";
 
   return os;
@@ -480,5 +487,7 @@
       (fXGeometryString      != v.fXGeometryString)      ||
       (fAutoRefresh          != v.fAutoRefresh)          ||
-      (fBackgroundColour     != v.fBackgroundColour))
+      (fBackgroundColour     != v.fBackgroundColour)     ||
+      (fPicking              != v.fPicking)
+      )
     return true;
 
Index: trunk/geant4/visualization/management/src/G4ViewerList.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4ViewerList.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4ViewerList.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ViewerList.cc,v 1.4 2006/06/29 21:29:32 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 #include "G4ViewerList.hh"
Index: trunk/geant4/visualization/management/src/G4VisCommands.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4VisCommands.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4VisCommands.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VisCommands.cc,v 1.20 2006/11/26 15:49:10 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4VisCommands.cc,v 1.22 2007/03/27 15:47:32 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 // /vis/ top level commands - John Allison  5th February 2001
@@ -40,4 +40,29 @@
 #include "G4Run.hh"
 #include "G4UIsession.hh"
+
+////////////// /vis/abortReviewKeptEvents /////////////////////////////
+
+G4VisCommandAbortReviewKeptEvents::G4VisCommandAbortReviewKeptEvents () {
+  G4bool omitable;
+
+  fpCommand = new G4UIcmdWithABool("/vis/abortReviewKeptEvents", this);
+  fpCommand -> SetGuidance("Abort review of kept events.");
+  fpCommand -> SetParameterName("abort", omitable=true);
+  fpCommand -> SetDefaultValue(true);
+}
+
+G4VisCommandAbortReviewKeptEvents::~G4VisCommandAbortReviewKeptEvents () {
+  delete fpCommand;
+}
+
+G4String G4VisCommandAbortReviewKeptEvents::GetCurrentValue (G4UIcommand*) {
+  return G4String();
+}
+
+void G4VisCommandAbortReviewKeptEvents::SetNewValue (G4UIcommand*,
+						     G4String newValue) {
+  fpVisManager->SetAbortReviewKeptEvents(G4UIcommand::ConvertToBool(newValue));
+  G4cout << "Type \"continue\" to complete the abort." << G4endl;
+}
 
 ////////////// /vis/enable ///////////////////////////////////////
@@ -128,9 +153,14 @@
   fpCommand -> SetGuidance
     ("If a macro file is specified, it is executed for each event.");
-  fpCommand -> SetGuidance
-    ("If a macro file is not specified, each event is drawn to the current"
-     "\nviewer.  After each event, the session is paused.  The user may issue"
-     "\nany allowed command.  Then enter \"continue\" to continue to the next"
-     "\nevent.");
+  fpCommand -> SetGuidance(
+  "If a macro file is not specified, each event is drawn to the current"
+  "\nviewer.  After each event, the session is paused.  The user may issue"
+  "\nany allowed command.  Then enter \"cont[inue]\" to continue to the next"
+  "\nevent."
+  "\nUseful commands might be:"
+  "\n  \"/vis/viewer/...\" to change the view (zoom, set/viewpoint,...)."
+  "\n  \"/vis/oglx/printEPS\" to get hard copy."
+  "\n  \"/vis/open\" to get alternative viewer."
+  "\n  \"/vis/abortReviewKeptEvents\", then \"cont[inue]\", to abort.");
   fpCommand -> SetParameterName("macro-file-name", omitable=true);
   fpCommand -> SetDefaultValue("");
@@ -185,6 +215,4 @@
   }
 
-  G4VSceneHandler* sceneHandler = fpVisManager->GetCurrentSceneHandler();
-
   G4UImanager* UImanager = G4UImanager::GetUIpointer();
   G4int keepVerbose = UImanager->GetVerboseLevel();
@@ -200,12 +228,24 @@
 
     // Draw to viewer and pause session...
+    G4UIsession* session = UImanager->GetSession();
     for (size_t i = 0; i < nKeptEvents; ++i) {
       const G4Event* event = (*events)[i];
       if (verbosity >= G4VisManager::warnings) {
 	G4cout << "Drawing event : " << event->GetEventID() <<
-	  ".  At EndOfEvent, enter any command, then \"continue\"..."
+	  ".  At EndOfEvent, enter any command, then \"cont[inue]\"..."
 	       << G4endl;
+	static G4bool first = true;
+	if (first) {
+	  first = false;
+	  G4cout <<
+  "  Useful commands might be:"
+  "\n    \"/vis/viewer/...\" to change the view (zoom, set/viewpoint,...)."
+  "\n    \"/vis/oglx/printEPS\" to get hard copy."
+  "\n    \"/vis/open\" to get alternative viewer."
+  "\n    \"/vis/abortReviewKeptEvents\", then \"cont[inue]\", to abort."
+		 << G4endl;
+	}
       }
-      sceneHandler->SetEvent(event);
+      fpVisManager->SetRequestedEvent(event);
       UImanager->ApplyCommand("/vis/viewer/rebuild");
       /* The above command forces a rebuild of the scene, including
@@ -224,10 +264,10 @@
          features or a complete re-think.
       */
-      if (!viewer->GetViewParameters().IsAutoRefresh())
-	UImanager->ApplyCommand("/vis/viewer/flush");
-      G4UIsession* session = UImanager->GetSession();
+      UImanager->ApplyCommand("/vis/viewer/flush");
       session->PauseSessionStart("EndOfEvent");
-      sceneHandler->SetEvent(0);
-    }
+      fpVisManager->SetRequestedEvent(0);
+      if (fpVisManager->GetAbortReviewKeptEvents()) break;
+    }
+    fpVisManager->SetAbortReviewKeptEvents(false);
 
   } else {
@@ -240,7 +280,7 @@
 	       << " with macro file \"" << macroFileName << G4endl;
       }
-      sceneHandler->SetEvent(event);
+      fpVisManager->SetRequestedEvent(event);
       UImanager->ApplyCommand("/control/execute " + macroFileName);
-      sceneHandler->SetEvent(0);
+      fpVisManager->SetRequestedEvent(0);
     }
   }
Index: trunk/geant4/visualization/management/src/G4VisCommandsCompound.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4VisCommandsCompound.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4VisCommandsCompound.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VisCommandsCompound.cc,v 1.35 2006/12/12 11:48:13 gcosmo Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4VisCommandsCompound.cc,v 1.38 2007/03/27 15:41:34 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 // Compound /vis/ commands - John Allison  15th May 2000
@@ -202,12 +202,11 @@
   UImanager->SetVerboseLevel(newVerbose);
   UImanager->ApplyCommand("/vis/scene/create");
-//  UImanager->ApplyCommand("/vis/scene/add/eventID");
   UImanager->ApplyCommand(G4String("/vis/scene/add/volume " + newValue));
   UImanager->ApplyCommand("/vis/sceneHandler/attach");
   UImanager->SetVerboseLevel(keepVerbose);
   static G4bool warned = false;
-  if (verbosity >= G4VisManager::warnings && !warned) {
+  if (verbosity >= G4VisManager::confirmations && !warned) {
     G4cout <<
-      "WARNING: For systems which are not \"auto-refresh\" you will need to"
+      "NOTE: For systems which are not \"auto-refresh\" you will need to"
       "\n  issue \"/vis/viewer/refresh\" or \"/vis/viewer/flush\"."
 	   << G4endl;
@@ -322,7 +321,7 @@
   UImanager->SetVerboseLevel(keepVerbose);
   static G4bool warned = false;
-  if (verbosity >= G4VisManager::warnings && !warned) {
+  if (verbosity >= G4VisManager::confirmations && !warned) {
     G4cout <<
-      "WARNING: For systems which are not \"auto-refresh\" you will need to"
+      "NOTE: For systems which are not \"auto-refresh\" you will need to"
       "\n  issue \"/vis/viewer/refresh\" or \"/vis/viewer/flush\"."
 	   << G4endl;
Index: trunk/geant4/visualization/management/src/G4VisCommandsGeometry.cc
===================================================================
--- trunk/geant4/visualization/management/src/G4VisCommandsGeometry.cc	(revision 592)
+++ trunk/geant4/visualization/management/src/G4VisCommandsGeometry.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VisCommandsGeometry.cc,v 1.3 2006/06/29 21:29:38 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// $Id: G4VisCommandsGeometry.cc,v 1.4 2007/01/05 16:29:38 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 
 // /vis/geometry commands - John Allison  31st January 2006
@@ -147,4 +147,6 @@
     return;
   }
-  G4UImanager::GetUIpointer()->ApplyCommand("/vis/viewer/rebuild");
+  if (fpVisManager->GetCurrentViewer()) {
+    G4UImanager::GetUIpointer()->ApplyCommand("/vis/viewer/rebuild");
+  }
 }
